#ifndef lint
static char *RCSid = "$Header: /sequent2/empire/EMP/player/commands/RCS/sell.c,v 1.6 89/09/10 19:22:40 mr-frog Exp $";
#endif

/*
 * rese.c
 *
 * Reset (lower) commodity prices
 *
 * Pat Loney, 1992
 */

#include "misc.h"
#include "xy.h"
#include "file.h"
#include "var.h"
#include "sect.h"
#include "item.h"
#include "nsc.h"
#include "nat.h"
#include "land.h"
#include "nuke.h"
#include "plane.h"
#include "ship.h"
#include "trade.h"
#include <math.h>		/* bailey@math-cs.kent.edu */
#include "commodity.h"
#include "player.h"

struct ichrstr *whichitem();

rese()
{
    extern char *argp[];
    struct comstr comm;
    struct sctstr sect;
    struct ichrstr *ip;
    struct ichrstr *ix;
    int     number_set;
    int     product, m;
    char	*p;
    float	price;
    time_t	now;
    s_char buf[1024];
    
    check_market();
    check_trade();
    if ((p = getstarg(player->argp[3], "Which lot :  ",buf)) == 0 || *p == 0)
	return RET_SYN;
    number_set = atoi(p);
    getcomm(number_set, &comm);
    if(comm.com_owner != player->cnum){
	pr("That's not your lot.\n");
	return RET_OK;
    }
    if(comm.com_maxbidder != player->cnum){
	pr("Some one already has a bid out on that\n");
	return RET_OK;
    }
    if ((p = getstarg(player->argp[4], "New (lower) price: ",buf)) == 0 || *p == 0)
	return RET_SYN;
    price = atof(p);
    if (price <= 0){
	getsect(comm.sell_x, comm.sell_y, &sect);
	if(!player->owner){
	    pr(" The destination sector must be one of yours\n");
	    return RET_OK;
	}
	if(sect.sct_type != SCT_TRADE || sect.sct_effic < 60){
	    pr(" The destination sector must be a 60%+ trading post\n");
	    return RET_OK;
	}
	ix = whichitem(comm.com_type);
	sect.sct_x = comm.sell_x;
	sect.sct_y = comm.sell_y;
	m = getvar(ix->i_vtype, (char *)&sect, EF_SECTOR);
	m = m + comm.com_amount;
	if (m > 9999)
	    m = 9999;
	putvar(ix->i_vtype, m, (char *)&sect, EF_SECTOR);
	putsect(&sect);
	comm.com_owner = 0;
	putcomm(number_set, &comm);
	pr("The goods have been returned to your trading post\n");
	return RET_OK;
    }
    if (price >= comm.com_price) {
	pr("You can only lower the price.\n");
	return RET_OK;
    }
    if (price < 0){
	pr("New price must be greater than or equal to zero.\n");
	return RET_OK;
    }
    comm.com_price = price;
    (void) time(&now);
    comm.com_markettime = now;
    if((int)price < comm.com_maxprice)
	comm.com_maxprice = (int) price;
    if(!putcomm(number_set, &comm)){
	pr("Problems with the commodities file, Call the Deity\n");
	return RET_OK;
    }
    return RET_OK;
}
