#ifndef lint
static char *RCSid = "$Header: /usr/brule/guest/empire/empire/emprcs/lib/subs/fileinit.c,v 2.2 1995/08/02 03:32:43 empire Exp $";
#endif /* not lint */

/*
 * fileinit.c
 *
 * Stuff that ef_init uses to initialize the
 * ca pointers and the pre/post i/o calls.
 * Only used by the client.
 *
 */

#include <fcntl.h>
#include "misc.h"
#include "xy.h"
#include "nsc.h"
#include "file.h"
#include "trade.h"
#include "commodity.h"
#include "loan.h"
#include "news.h"

extern	struct castr sect_ca[];
extern	struct castr news_ca[];
extern	struct castr loan_ca[];
extern	struct castr ship_ca[];
extern	struct castr plane_ca[];
extern	struct castr treaty_ca[];
extern	struct castr nuke_ca[];
extern	struct castr trade_ca[];
extern  struct castr commodity_ca[];

extern	int sct_init(), sct_postread(), sct_prewrite(), sct_validate();
extern	int shp_init(), shp_postread(), shp_prewrite(), shp_validate();
extern	int lnd_init(), lnd_postread(), lnd_prewrite(), lnd_validate();
extern	int pln_init(), pln_postread(), pln_prewrite(), pln_validate();
extern	int nuk_init(), nuk_postread(), nuk_prewrite();
int trd_init(), trd_prewrite(), lon_init(), lon_prewrite();
int nws_init(), nws_prewrite(), com_init(), com_prewrite();

struct fileinit fileinit[EF_MAX] = {
sct_init,	sct_postread,	sct_prewrite,	sct_validate,	sect_ca,
shp_init,	shp_postread,	shp_prewrite,	shp_validate,	ship_ca,
pln_init,	pln_postread,	pln_prewrite,	pln_validate,	plane_ca,
lnd_init,	lnd_postread,   lnd_prewrite,   lnd_validate,	land_ca,
nuk_init,	nuk_postread,	nuk_prewrite,	0,		nuke_ca,
nws_init,	0,		nws_prewrite,	0,		news_ca,
0,		0,		0,		0,		treaty_ca,
trd_init,	0,		trd_prewrite,	0,		trade_ca,
0,		0,		0,		0,		0,/* power */
0,		0,		0,		0,		0,/* nation */
lon_init,	0,		lon_prewrite,	0,		loan_ca,
0,		0,		0,		0, 		0,/* map */
0,		0,		0,		0,		0,/* map */
com_init,	0,		com_prewrite,	0,		commodity_ca,
};

ef_init()
{
	int	i;
	struct	empfile *ef;
	struct	fileinit *fi;

	ef = empfile;
	fi = fileinit;
	for (i=0; i<EF_MAX; i++, ef++, fi++) {
		ef->init = fi->init;
		ef->postread = fi->postread;
		ef->prewrite = fi->prewrite;
		ef->validate = fi->validate;
		ef->cadef = fi->cadef;
	}
}

nws_init(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	nwsstr *np = (struct nwsstr *)ptr;

	np->ef_type = EF_NEWS;
	np->nws_uid = n;
}

nws_prewrite(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	nwsstr *np = (struct nwsstr *)ptr;

	np->ef_type = EF_NEWS;
	np->nws_uid = n;
}

trd_init(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	trdstr *tp = (struct trdstr *)ptr;

	tp->ef_type = EF_TRADE;
	tp->trd_uid = n;
}

trd_prewrite(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	trdstr *tp = (struct trdstr *)ptr;

	tp->ef_type = EF_TRADE;
	tp->trd_uid = n;
}

lon_init(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	lonstr *lp = (struct lonstr *)ptr;

	lp->ef_type = EF_LOAN;
	lp->l_uid = n;
}

lon_prewrite(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	lonstr *lp = (struct lonstr *)ptr;

	lp->ef_type = EF_LOAN;
	lp->l_uid = n;
}

com_init(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	comstr *cp = (struct comstr *)ptr;

	cp->ef_type = EF_COMM;
	cp->com_uid = n;
}

com_prewrite(n, ptr)
	int	n;
	s_char	*ptr;
{
	struct	comstr *cp = (struct comstr *)ptr;

	cp->ef_type = EF_COMM;
	cp->com_uid = n;
}
